#
# jam: java automated make
#
# a general make script and makefile to compile all java files
# in a directory tree (project)
#
# Another Aromatic Productions
#   http://www.aromatic.com/
#
# Copyright (C) 1998 Raffaele Sena (raff@aromatic.com)
# All rights reserved
#
# Version: 1.0	- Feb 1 1998
#

#
##########################################################################
#
# The .java to .class rule
#
.SUFFIXES: .java .class

#
##########################################################################
#
# Default java sdk tools
#
# Can be overridden by a redefinition in jam.def
#

#
# Compiler
#
JC=javac -J-mx128M -d classes 

#
# Virtual machine
#
JVM = java

#
# Debugger
#
JD = jdb

#
#
##########################################################################
#
# compile all the sources from current directory down
#
SOURCES = ${shell find src -name "*.java" -print}
TARGETS_TMP = $(SOURCES:.java=.class)
TARGETS = $(subst src,classes,${TARGETS_TMP})

all: ${TARGETS}

$(TARGETS): classes/%.class: src/%.java
	$(JC) $<


#
##########################################################################
#
# remove all the class files
#
clean:
	-rm -rf ${TARGETS}

#
##########################################################################
#
# local definitions can be set in the user defined file jam.def.
# If it doesn't exist, we'll create it here (just to remove an annoying
# make warning
#
jams.def:
	touch jams.def

include jams.def

#
# JMAIN is the main program for this project
# if defined, a run target and a debug target will be defined
#
ifdef JMAIN
run:
	$(JVM) $(JMAIN)

debug:
	$(JD) $(JMAIN)
endif
